# ADDQRY.pl
#
# AmiBug.Com
# Perl Based Test Case Generator
#
# Author: Robert Sabourin
# Copyright 2003 AmiBug.Com, Inc.
#
# Revision History:
#
# 2003-08-13
# Created.
#
# Documentation:
#
# perl ADDQRY.pl n
#
# n is number of test cases to create.
#
#
# Start of code!
#

my $tccount = $ARGV[0];   # number of processes from first parameter


#
# Get four file TEMPLATES
#
# TPQRYPAT.mst
# TPADDPAT.mst
# TPQRYPAT.log
# TPADDPAT.log
#
        open(INFILEA, "<", "TPQRYPAT.mst");
        @BINTPQRYPAT_mst=<INFILEA>;
        close(INFILEA);

        open(INFILEA, "<", "TPADDPAT.mst");
        @BINTPADDPAT_mst=<INFILEA>;
        close(INFILEA);

        open(INFILEA, "<", "TPQRYPAT.log");
        @BINTPQRYPAT_log=<INFILEA>;
        close(INFILEA);

        open(INFILEA, "<", "TPADDPAT.log");
        @BINTPADDPAT_log=<INFILEA>;
        close(INFILEA);
#
# process
#

#
# Get current time to second from time functions
#
($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = gmtime(time);
#
# Name of output directory is built from time to second formated with sprintf
#
$patbase = sprintf( "%04s%02s%02s%02s%02s%02s", $year+1900, $mon+1, $mday, $hour, $min, $sec);

#
# Header of manifest.csv
#

open(OUTFILEA, ">". "manifest.csv");
print OUTFILEA "TCIN001,START,NA,NA,NA,NA", "\n";
print OUTFILEA "TCIN002,HOPEN,10.93.3.141,5005,NA,NA", "\n";
print OUTFILEA "TCIN003,DELAY,5,NA,NA,NA", "\n";
close(OUTFILEA);


#
# write four output files in a loop
#
    for ($i = 0; $i < $tccount; $i = $i + 1)
        {
        #
        # Build onto unique string
        #
        $patstring = $patbase . $i ;
        $tcstring = "TC_" . $i ;
        #
        # Now substitute in files 
        # replace PAT with contents of $patstring
        #

        $len = $#BINTPQRYPAT_mst + 1;
print $len,"\n";
        for ($j=0; $j < $len; $j=$j+1)
            {
            $lintem = @BINTPQRYPAT_mst[$j];
print $lintem, "\n";
            $lintem =~ s/PAT/$patstring/g;
print $lintem, "\n";
            @BINRSQRYPAT_mst[$j]=$lintem;
            }
        #
        # Update four files

        $qm = "QRYPAT_" . $patstring . ".mst";
        open(OUTFILEA, ">", $qm);
        print OUTFILEA @BINRSQRYPAT_mst;
        close(OUTFILEA);

        $len = $#BINTPADDPAT_mst + 1;
print $len,"\n";
        for ($j=0; $j < $len; $j=$j+1)
            {
            $lintem = @BINTPADDPAT_mst[$j];
print $lintem, "\n";
            $lintem =~ s/PAT/$patstring/g;
print $lintem, "\n";
            @BINRSADDPAT_mst[$j]=$lintem;
            }


        $am = "ADDPAT_" . $patstring . ".mst";
        open(OUTFILEA, ">", $am);
        print OUTFILEA @BINRSADDPAT_mst;
        close(OUTFILEA);

        $len = $#BINTPQRYPAT_log + 1;
print $len,"\n";
        for ($j=0; $j < $len; $j=$j+1)
            {
            $lintem = @BINTPQRYPAT_log[$j];
print $lintem, "\n";
            $lintem =~ s/PAT/$patstring/g;
print $lintem, "\n";
            @BINRSQRYPAT_log[$j]=$lintem;
            }



        $ql = "QRYPAT_" . $patstring . ".log";
        open(OUTFILEA, ">", $ql);
        print OUTFILEA @BINRSQRYPAT_log;
        close(OUTFILEA);

        $len = $#BINTPADDPAT_log + 1;
print $len;
        for ($j=0; $j < $len; $j=$j+1)
            {
            $lintem = @BINTPADDPAT_log[$j];
print $lintem, "\n";
            $lintem =~ s/PAT/$patstring/g;
print $lintem, "\n";
            @BINRSADDPAT_log[$j]=$lintem;
            }

        $al = "ADDPAT_" . $patstring . ".log";
        open(OUTFILEA, ">", $al);
        print OUTFILEA @BINRSADDPAT_log;
        close(OUTFILEA);


        $ao = "ADDPAT_" . $patstring . ".out";
        $qo = "QRYPAT_" . $patstring . ".out";

        open(OUTFILEA, ">>". "manifest.csv");
        print OUTFILEA $tcstring, "A", ",", "HSEND", ",", $al, ",", $ao, ",", "1",",", $am, "\n";
        print OUTFILEA $tcstring, "B", ",", "HSEND", ",", $ql, ",", $qo, ",", "1",",", $qm, "\n";        
        close(OUTFILEA);
        #
        #
        } # end of for loop

        open(OUTFILEA, ">>". "manifest.csv");
        print OUTFILEA "TCIN012,DELAY,3,NA,NA,NA", "\n";
        print OUTFILEA "TCIN013,HCLOSE,NA,NA,NA,NA", "\n";
        print OUTFILEA "TCIN014,END,NA,NA,NA,NA", "\n";
        close(OUTFILEA);
