# AmiTestLauncher.pl
#
# AmiBug.Com
# Perl Based Test Launcher
#
# Author: Robert Sabourin
# Copyright 2003 AmiBug.Com, Inc.
#
# Revision History:
#
# 2003-08-11
# Created.
#
# Documentation:
#
# perl AmiTestLauncher.pl n
#
# n is number of instances of test harness AmiTestHarness.pl to launch.
#
#
# Start of code!
#
use Win32::Process;
use Win32;


my $proccount = $ARGV[0]; # number of processes from first parameter
my $procid = "";          # local process id counter
my @procids = "";         # array containing a list of process ids
my @logpaths = "";        # output files for test results - one per process
my $outpath = "";         # tempory version of output directory file name
my $inpath = "C:\\dev\\perl\\scratchfiles\\makeinsertquerystuff"; # input files and manifest

# no max count

my $loopcount = 0;     # initialize process loop counter

while ( $loopcount < $proccount ){
    #
    # Get current time to second from time functions
    #
    ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = gmtime(time);
    #
    # Name of output directory is built from time to second formated with sprintf
    #
    $outpath = "Ami_" . sprintf( "%02s_%04s_%02s_%02s_%02s_%02s_%02s", $loopcount, $year+1900, $mon+1, $mday, $hour, $min, $sec);
    #
    # launch process returning procid object
    #
    Win32::Process::Create($procid,
                                "D:\\Perl\\bin\\perl.exe",                              
                                "perl C:\\dev\\perl\\scratchfiles\\makeinsertquerystuff\\AmiTestHarness.pl $inpath $outpath",
                                0,
                                HIGH_PRIORITY_CLASS,
                                ".");
    @procids[$loopcount]=$procid;
    @logpaths[$loopcount]=$outpath;
    sleep 2; # pause two seconds between process launches
    $loopcount = $loopcount + 1;

    print $procid, " ", $outpath, " ", $loopcount, "\n";

    } # end of while loop

#
# Design for monitor
#
# loop forever
#
while ( "T" eq "T" )
    {
    print "________________________________________________________________________________\n";
    # for each process
    $loopcount = 0;     # initialize process loop counter
    while ( $loopcount < $proccount )
       {
       $filename = $inpath . "\\" . $logpaths[$loopcount] . "\\" . "logfile.csv";

       open(LOGFILE,'<',$filename);
       # count in loop
       $failcount = 0;
       $passcount = 0;
       $tccase = 0;

       while(<LOGFILE>)
            {
            $tccase++; # one extra test case per line
            $failcount++ if (/FAIL/);
            $passcount++ if (/PASS/);
            }
       close $LOGFILE;

       print "proc index ", $loopcount, " test cases ", $tccase, " fails ", $failcount, " passed ", $passcount, "\n";

       #
       # experimental resume to see if windows behaves better
       # basically resume just in case windows has suspended the process
       # this code section is inspired by the concept of CYCLING THE OXYGEN TANKS from
       # Apollo 13.  We cycle the process to make sure it is give the cycles it should get.
       #
       $procid=@procids[$loopcount];
       $procid->Suspend;
       $procid->Resume;
       #
       # end of experiment
       #
       sleep 2; # wait a couple of seconds
       $loopcount = $loopcount + 1;
       
       } # end for each process
    } # end while forever
